package s;

import java.io.*;
import javax.ws.rs.*;
import javax.ws.rs.core.*;
import bib.*;

@Path("/")
public class ServiceRj {
    @GET
    @Path("ping")
    @Produces("application/xml")
    public StreamingOutput ping() throws Exception {
        final String res = Bib.ping("RESTful", "ServiceRj", "8080");
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @PUT
    @Path("add/{a}/{b}")
    @Produces("application/xml")
    @Consumes("application/xml")
    public StreamingOutput add(@PathParam("a") int a, @PathParam("b") int b) {
        final String res = "" + Bib.add(a, b);
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @PUT
    @Path("subtract/{a}/{b}")
    @Produces("application/xml")
    @Consumes("application/xml")
    public StreamingOutput subtract(@PathParam("a") int a, @PathParam("b") int b) {
        final String res = "" + Bib.subtract(a, b);
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @PUT
    @Path("multiply/{a}/{b}")
    @Produces("application/xml")
    @Consumes("application/xml")
    public StreamingOutput multiply(@PathParam("a") int a, @PathParam("b") int b) {
        final String res = "" + Bib.multiply(a, b);
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @PUT
    @Path("divide/{a}/{b}")
    @Produces("application/xml")
    @Consumes("application/xml")
    public StreamingOutput divide(@PathParam("a") int a, @PathParam("b") int b)
            throws Exception {
        final String res = "" + Bib.divide(a, b);
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @PUT
    @Path("mod/{a}/{b}")
    @Produces("application/xml")
    @Consumes("application/xml")
    public StreamingOutput mod(@PathParam("a") int a, @PathParam("b") int b)
            throws Exception {
        final String res = "" + Bib.mod(a, b);
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @PUT
    @Path("intPow/{a}/{b}")
    @Produces("application/xml")
    @Consumes("application/xml")
    public StreamingOutput intPow(@PathParam("a") int a, @PathParam("b") int b)
            throws Exception {
        final String res = "" + Bib.intPow(a, b);
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @POST
    @Path("toFpp")
    @Produces("application/xml")
    @Consumes("application/x-www-form-urlencoded")
    public StreamingOutput upcaseP(@FormParam("infix") String infix) {
        final String res = Bib.toFpp(infix);
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    protected void writeRasp(OutputStream os, String res) {
        PrintStream writer = new PrintStream(os);
        writer.print(res);
        writer.close();
    }
}
