package s;

import javax.xml.ws.Endpoint;
import javax.jws.WebMethod;
import javax.jws.WebService;
import java.util.*;
import bib.*;

@WebService
public class ServiceSj {
    @WebMethod
    public String ping() throws Exception {
        return Bib.ping("SOAP", "ServiceSj", "2002");
    }

    @WebMethod
    public int add(int a, int b) {
        return Bib.add(a, b);
    }

    @WebMethod
    public int subtract(int a, int b) {
        return Bib.subtract(a, b);
    }

    @WebMethod
    public int multiply(int a, int b) {
        return Bib.multiply(a, b);
    }

    @WebMethod
    public int divide(int a, int b) throws Exception {
        return Bib.divide(a, b);
    }

    @WebMethod
    public int mod(int a, int b) throws Exception {
        return Bib.mod(a, b);
    }

    @WebMethod
    public int intPow(int a, int b) throws Exception {
        return Bib.intPow(a, b);
    }

    @WebMethod
    public String toFpp(String infix) {
        return Bib.toFpp(infix);
    }

    public ServiceSj() {
        ;
    }

    public ServiceSj(String urlServ) throws Exception {
        Hashtable<String, String> url = Hurl.hurl(urlServ);
        int port = Integer.parseInt(url.get("port"));
        Endpoint endpoint = Endpoint.publish("http://" + url.get("host") + ":"
                + url.get("port") + "/", new ServiceSj());
        System.out.println("Java SOAP ServiceSj waiting at: "
                + urlServ);
    }

    public static void main(String[] args) throws Exception {
        if (args.length > 0)
            new ServiceSj(args[0]);
        else
            new ServiceSj("http://0.0.0.0:2002");
    }
}
