import org.apache.xmlrpc.webserver.*;
import org.apache.xmlrpc.server.*;
import java.util.*;
import bib.*;

public class ServiceXj {
    public String ping() throws Exception {
        return Bib.ping("XML-RPC", "ServiceXj", "1002");
    }

    public Integer add(Integer a, Integer b) {
        return Bib.add(a, b);
    }

    public Integer subtract(Integer a, Integer b) {
        return Bib.subtract(a, b);
    }

    public Integer multiply(Integer a, Integer b) {
        return Bib.multiply(a, b);
    }

    public Integer divide(Integer a, Integer b) throws Exception {
        return Bib.divide(a, b);
    }

    public Integer mod(Integer a, Integer b) throws Exception {
        return Bib.mod(a, b);
    }

    public Integer intPow(Integer a, Integer b) throws Exception {
        return Bib.intPow(a, b);
    }

    public String toFpp(String infix) {
        return Bib.toFpp(infix);
    }

    public ServiceXj() {
        ;
    }

    public ServiceXj(String urlServ) throws Exception {
        Hashtable<String, String> url = Hurl.hurl(urlServ);
        int port = Integer.parseInt(url.get("port"));
        String pathServ = url.get("path");
        WebServer webServer = new WebServer(port);
        XmlRpcServer serviciu = webServer.getXmlRpcServer();
        XmlRpcServerConfigImpl config = new XmlRpcServerConfigImpl();
        serviciu.setConfig(config);
        PropertyHandlerMapping mapping = new PropertyHandlerMapping();
        mapping.addHandler(pathServ, ServiceXj.class);
        serviciu.setHandlerMapping(mapping);
        System.out.println("Java XML-RPC service " + pathServ + " waiting at: "
                + urlServ);
        webServer.start();
    }

    public static void main(String[] args) throws Exception {
        if (args.length > 1)
            new ServiceXj(args[0]);
        else
            new ServiceXj("http://0.0.0.0:1002/Xj");
    }
}
