package bib;

import java.net.*;
import java.util.*;

public class Bib {

    public static String ping(String tip, String pathServ, String port) throws Exception {
        InetAddress host = InetAddress.getLocalHost();
        return "Java " + tip + " " + pathServ + ": " + host.getHostName()
                + " (" + host.getHostAddress() + ": " + port + "), "
                + new Date();
    }

    public static Integer add(Integer a, Integer b) {
        return a + b;
    }

    public static Integer subtract(Integer a, Integer b) {
        return a - b;
    }

    public static Integer multiply(Integer a, Integer b) {
        return a * b;
    }

    public static Integer divide(Integer a, Integer b) throws Exception {
        try {
            return a / b;
        } catch (Exception e) {
            throw new Exception("divide: Impartire la zero" + e);
        }
    }

    public static Integer mod(Integer a, Integer b) throws Exception {
        try {
            return a % b;
        } catch (Exception e) {
            throw new Exception("mod: Impartire la zero" + e);
        }
    }

    public static Integer intPow(Integer a, Integer b) throws Exception {
        int p = 1;
        try {
            for (int i = 1; i <= b; i++, p *= a)
                ;
            return p;
        } catch (Exception e) {
            throw new Exception("intPow: Depasire" + e);
        }
    }

    public static String toFpp(String infix) {
        infix = infix.trim();
        int i, p, varf = -1;
        char c, u;
        String s, d, r;
        String postfix = "";
        String eval = "";
        String apeluri = "";
        String operatori = "+-*/%^";
        String priority = "112223";
        String albe = " \t\n\r";
        String alfabet = "0123456789" + operatori + albe + "()";
        ArrayList<Character> stiva = new ArrayList<Character>();
        ArrayList<String> operanzi = new ArrayList<String>();
        StringBuffer sb = new StringBuffer(infix);
        for (i = sb.length() - 1; i >= 0; i--) {
            c = sb.charAt(i);
            if (alfabet.indexOf(c) == -1)
                return infix + "\nERROR caracter interzis!\n";
            if (albe.indexOf(c) >= 0)
                sb.deleteCharAt(i);
            if (i < sb.length() - 1)
                u = sb.charAt(i + 1);
            else
                u = ' ';
            if (c == '(')
                if (u == '+')
                    sb.deleteCharAt(i + 1);
                else if (u == '-')
                    sb.insert(i + 1, '0');
        } // Control alfabet, sters toate spatiile albe, rezolvat + si - unar
        if (sb.length() > 0)
            if (sb.charAt(0) == '+')
                sb.deleteCharAt(0);
            else if (sb.charAt(0) == '-')
                sb.insert(0, '0');
        for (; sb.length() > 0;) {
            c = sb.charAt(0);
            i = operatori.indexOf(c);
            if (Character.isDigit(c)) { // operand
                for (i = 0; i < sb.length() && Character.isDigit(sb.charAt(i)); i++)
                    ;
                postfix += "#" + sb.substring(0, i) + "|";
                eval += "#";
                sb.delete(0, i - 1);
            } else if (i != -1) { // operatori
                for (;;) {
                    if (varf < 0)
                        break;
                    p = operatori.indexOf(stiva.get(varf));
                    if (p < 0 || priority.charAt(p) < priority.charAt(i))
                        break;
                    p = eval.length();
                    if (p < 2)
                        return infix + "\nERROR operatori fara operanzi\n";
                    postfix += stiva.get(varf);
                    eval = eval.substring(0, p - 1);
                    stiva.remove(varf);
                    varf--;
                }
                stiva.add(c);
                varf++;
            } else if (c == '(') { // pune ( in stiva
                stiva.add(c);
                varf++;
            } else if (c == ')') { // extrage din stiva pana la ( si genereaza
                                   // corespunzator
                for (;;) {
                    if (varf < 0)
                        return infix + "\nERROR paranteze incorecte!\n";
                    c = stiva.get(varf);
                    stiva.remove(varf);
                    varf--;
                    if (c == '(')
                        break;
                    p = eval.length();
                    if (p < 2)
                        return infix + "\nERROR operatori fara operanzi\n";
                    postfix += c;
                    eval = eval.substring(0, p - 1);
                }
            }
            sb.deleteCharAt(0);
        }
        for (; varf >= 0;) { // golestre stiva de ultimii operatori si genereaza
            if (stiva.get(varf) == '(')
                return infix + "\nERROR paranteze incorecte!\n";
            p = eval.length();
            if (p < 2)
                return infix + "ERROR operatori fara operanzi\n";
            eval = eval.substring(0, p - 1);
            postfix += stiva.get(varf);
            stiva.remove(varf);
            varf--;
        }
        if (eval.length() != 1)
            return infix + "\nERROR prea multi operanzi\n";
        sb = new StringBuffer(postfix);
        p = 0;
        for (; sb.length() > 0;) { // construieste succesiunea de apeluri
            c = sb.charAt(0);
            if (c == '#') {
                i = sb.indexOf("|");
                operanzi.add("\"" + sb.substring(1, i) + "\"");
                sb.delete(0, i + 1);
            } else {
                sb.deleteCharAt(0);
                varf = operanzi.size() - 1;
                d = operanzi.get(varf);
                s = operanzi.get(varf - 1);
                if (s.charAt(0) == '\"' && d.charAt(0) == '\"')
                    r = "" + (p++);
                else if (s.charAt(0) == '\"')
                    r = d;
                else
                    r = s;
                operanzi.set(varf - 1, r);
                operanzi.remove(varf);
                apeluri += r + "=" + s + c + d + "\n";
            }
        }
        apeluri += operanzi.get(0) + "\n";
        return apeluri + postfix + "\n" + infix;
    }
}
