<?php
require_once("xmlrpc.inc");
require_once("xmlrpcs.inc");
require_once("Bib.php");
class ServiceXh {
    function ping () {
        return new xmlrpcresp(new xmlrpcval(Bib::ping("XML-RPC", "ServiceXh", "80"), "string"));
    }
    function add($msg) {
        $a = php_xmlrpc_decode($msg->params[0]);
        $b = php_xmlrpc_decode($msg->params[1]);
        return new xmlrpcresp(new xmlrpcval(Bib::add($a, $b), "int"));
    }
    function subtract($msg) {
        $a = php_xmlrpc_decode($msg->params[0]);
        $b = php_xmlrpc_decode($msg->params[1]);
        return new xmlrpcresp(new xmlrpcval(Bib::subtract($a, $b), "int"));
    }
    function multiply($msg) {
        $a = php_xmlrpc_decode($msg->params[0]);
        $b = php_xmlrpc_decode($msg->params[1]);
        return new xmlrpcresp(new xmlrpcval(Bib::multiply($a, $b), "int"));
    }
    function divide($msg) {
        $a = php_xmlrpc_decode($msg->params[0]);
        $b = php_xmlrpc_decode($msg->params[1]);
        $r = Bib::divide($a, $b);
        if (is_numeric($r))
            return new xmlrpcresp(new xmlrpcval($r, "int"));
        else
            return new xmlrpcresp(new xmlrpcval($r, "string"));
    }
    function mod($msg) {
        $a = php_xmlrpc_decode($msg->params[0]);
        $b = php_xmlrpc_decode($msg->params[1]);
        $r = Bib::mod($a, $b);
        if (is_numeric($r))
            return new xmlrpcresp(new xmlrpcval($r, "int"));
        else
            return new xmlrpcresp(new xmlrpcval($r, "string"));
    }
    function intPow($msg) {
        $a = php_xmlrpc_decode($msg->params[0]);
        $b = php_xmlrpc_decode($msg->params[1]);
        return new xmlrpcresp(new xmlrpcval(Bib::intPow($a, $b), "int"));
    }
    function toFpp($msg) {
        $infix = php_xmlrpc_decode($msg->params[0]);
        return new xmlrpcresp(new xmlrpcval(Bib::toFpp($infix), "string"));
    }
    function start() {
        $serv = new xmlrpc_server(
                array(
                        "ping" =>
                        array(
                                "function" => "ServiceXh::ping",
                                "signature" => array(array("string"))
                        ),
                        "add" =>
                        array(
                                "function" => "ServiceXh::add",
                                "signature" => array(array("int", "int", "int"))
                        ),
                        "subtract" =>
                        array(
                                "function" => "ServiceXh::subtract",
                                "signature" => array(array("int", "int", "int"))
                        ),
                        "multiply" =>
                        array(
                                "function" => "ServiceXh::multiply",
                                "signature" => array(array("int", "int", "int"))
                        ),
                        "divide" =>
                        array(
                                "function" => "ServiceXh::divide",
                                "signature" => array(array("int", "int", "int"))
                        ),
                        "mod" =>
                        array(
                                "function" => "ServiceXh::mod",
                                "signature" => array(array("int", "int", "int"))
                        ),
                        "intPow" =>
                        array(
                                "function" => "ServiceXh::intPow",
                                "signature" => array(array("int", "int", "int"))
                        ),
                        "toFpp" =>
                        array(
                                "function" => "ServiceXh::toFpp",
                                "signature" => array(array("string", "string"))
                        )
                ), false
        );
        $serv->service();
    }
}
$serviciu = new ServiceXh();
$serviciu->start();
?>
